;**************************************************************
;*	CFU Animations-Optionen 
;*  Fügt Pausenzeit und Einzelübergang dem Ebenennamen hinzu
;*  oder ändert sie
;*	Geschrieben für GIMP 2.6
;*
;*
;*	Einstellbare Parameter:
;*
;*  "Welche Pausenzeit soll geändert werden" "Alle Ebenen" 
;*                                           "Aktive Ebene" 
;*                                           "Ebenen ohne Pausenzeit"
;*                                           "Ebenen mit Pausenzeit"
;*                                           "Ebenen mit eingestellter Pausenzeit X"
;* 	"Eingestellte Pausenzeit X" '
;*  "Welcher Einzelübergang soll geändert werden" "Egal" "Ersetzen" "Kombinieren" "Leere" "Nicht Leere"
;*  "Was soll geändert werden" "Pausenzeit" "Pausenzeit und Einzelübergang" "Einzelübergang"
;* 	"Pausenzeit in ms " 
;*  "Einzelübergang" "Ersetzen" "Kombinieren" "Einzelübergang Entfernen"
;*
;*
;*	V1.0 vom Freitag dem "13.04.2012"  
;*
;**************************************************************     

(define (script-fu-cf-tools-aniopt inBild inEbene inPZE inPZAlt inUEE inWas inPZNeu inUENeu)			;Beginn (define)
  (let* (
;          (outBild (car (gimp-image-duplicate inBild)))                    		
          (outBild inBild)                    		
          (layers (gimp-image-get-layers outBild))
       		(oldLayer (car (gimp-image-get-active-layer outBild)))
          (num-layers (car layers))
          (layer-array (cadr layers))
          (i  num-layers)
          (l 0)
          (tl 0)
          (ListeDrawName '())
          (TeilListe '())
          (ListeLength 0)
          (TeilListeLength 0)
          (Ziffern "")
          (ZiffernL 0)
          (pPZNeu (if (= inPZNeu 0)
                    (string-append "")
                    (string-append " (" (number->string inPZNeu) "ms)")
                  ))                                                 
          (pUENeu (case inUENeu
                    ((0) " (replace)")
                    ((1) " (combine)")
                    ((2) "")
                  ))  
          (zPZAlt (string-append " (" (number->string inPZAlt) "ms)"))
          (pPZAlt "")
          (pUEAlt "")
          (Teil0 "")
          (Teil1 "")
          (Teil2 "")
          (TLT0 "")
          (TLT1 "")
          (TLT2 "")
          (startl 0)
          (stopl 0)
          (sollDieserUE  FALSE)
          (sollDieseZeit FALSE)
          (sollNeuerName FALSE)
          (ActiveEbene 0)
          (NameNeu "")
          (NameAlt "")
        )

		(gimp-undo-push-group-start outBild)

    (while (> i 0)
      (begin 	  	    
        (set! i (- i 1))    
        
        (if (= inPZE 1)
          (begin
            (set! ActiveEbene oldLayer)	
            (set! i 0)
          )
          (set! ActiveEbene (vector-ref layer-array i))	 
        )       
        
        (set! NameAlt (car(gimp-drawable-get-name ActiveEbene)))
        
        (set! pPZAlt "")
        (set! pUEAlt "")
        (set! NameNeu "")
        (set! l 1)
        (set! ListeDrawName(strbreakup NameAlt "("))
        (set! ListeLength (length ListeDrawName))
        
        (set! NameNeu (string-trim (car ListeDrawName)))
        (set! Teil2 ListeDrawName)
        
        (while (< l ListeLength)
          (begin
            (set! Teil2 (cdr Teil2))
            (set! Teil1 (car Teil2))
            (set! Teil0 (string-trim Teil1))
            
            (set! TeilListe (strbreakup Teil0 ")"))
            (set! TeilListeLength (length TeilListe))
            
            ( if (> TeilListeLength 1)
              (begin
                (set! TLT1 (car TeilListe)) 
                (set! TLT2 (cdr TeilListe))
                (set! TLT0 (string-trim TLT1))


                (set! stopl (string-length TLT0))
                (set! startl (- stopl 2))
                (if (< startl 0)
                (set! startl 0))
                
                (cond  
                  ((string=? TLT0 "combine")(set! pUEAlt " (combine)"))
                  ((string=? TLT0 "replace")(set! pUEAlt " (replace)"))
                  (else 
                    (begin
                      (set! Ziffern (string-trim(substring TLT0 0 (- (string-length TLT0) 2))))
                      (if (re-match "^[0-9]+$" Ziffern)
                        (set! pPZAlt (string-append " (" TLT0 ")"))
                        (set! NameNeu (string-append NameNeu " (" TLT0 ")" ))                      
                      )
                    )
                  )
                )

                (set! NameNeu (string-append NameNeu (unbreakupstr TLT2 ")")))
                
              )
              (begin
                (set! NameNeu (string-append NameNeu " (" Teil0))
              )
            )
                                    
            (set! l (+ l 1))
            
          )
        )
        
        (set! sollDieseZeit FALSE)
        (set! sollDieserUE  FALSE)
        (set! sollNeuerName FALSE)
        (cond
          ((= inPZE 0)(set! sollDieseZeit TRUE))
          ((and(= inPZE 1)(= oldLayer ActiveEbene))(set! sollDieseZeit TRUE))
          ((and(= inPZE 2)(string=? pPZAlt ""))(set! sollDieseZeit TRUE))
          ((and(= inPZE 3)(string>? pPZAlt ""))(set! sollDieseZeit TRUE))
          ((and(= inPZE 4)(string=? zPZAlt pPZAlt))(set! sollDieseZeit TRUE))
        )

        (cond
          ((= inUEE 0)(set! sollDieserUE TRUE))
          ((and(= inUEE 1)(string=? pUEAlt " (replace)"))(set! sollDieserUE TRUE))
          ((and(= inUEE 2)(string=? pUEAlt " (combine)"))(set! sollDieserUE TRUE))
          ((and(= inUEE 3)(string=? pUEAlt ""))(set! sollDieserUE TRUE))
          ((and(= inUEE 4)(string>? pUEAlt ""))(set! sollDieserUE TRUE))
        )
        
        (if (and (= sollDieseZeit TRUE)(= sollDieserUE TRUE)) 
          (set! sollNeuerName TRUE) 
        )
        
        (if (= sollNeuerName TRUE)
          (begin
        
            (if (< inWas 2)
              (set! NameNeu (string-append NameNeu  pPZNeu))
              (set! NameNeu (string-append NameNeu  pPZAlt))
            )

            (if (> inWas 0)
              (set! NameNeu (string-append NameNeu  pUENeu))
              (set! NameNeu (string-append NameNeu  pUEAlt))
            )

            (gimp-drawable-set-name ActiveEbene NameNeu)     
          )
        )
        
        (gimp-progress-update (/ (- num-layers i) num-layers))

      )
    )
    
    (set! inPZAlt inPZNeu)
    
;  	(gimp-display-new outBild)
    (gimp-displays-flush)
		(gimp-undo-push-group-end outBild)
    
  )                         ; Ende let*
) 													; Ende (define)
 
 
(script-fu-register									;Beginn (script-fu-register)
	"script-fu-cf-tools-aniopt"				;Name der Funktion, die aufgerufen werden soll
	"CFU Animationsoptionen"                  		;Name des Skripts
	"Fügt Pausenzeit und Einzelübergang dem Ebenennamen hinzu" ;Beschreibung des Skripts
	"CF"                                     		;Name des Autors
	"Copyleft by CF"                         		;Copyright-Infos
	"13.04.2012"                             		;Datum Freitag der Dreizehnte
	"RGB* GRAY* INDEXED*"                   		;Bildtypen
	SF-IMAGE "Das Bild" 0
	SF-DRAWABLE "Die Ebene" 0  
  SF-OPTION "Welche Pausenzeit soll geändert werden" '( "Alle Ebenen" 
                                                        "Aktive Ebene" 
                                                        "Ebenen ohne Pausenzeit"
                                                        "Ebenen mit Pausenzeit"
                                                        "Ebenen mit eingestellter Pausenzeit X"
                                                        )
 	SF-ADJUSTMENT "Eingestellte Pausenzeit X" '(50 0 10000 1 10 0 1)
  SF-OPTION "Welcher Einzelübergang soll geändert werden" '("Egal" "Ersetzen" "Kombinieren" "Leere" "Nicht Leere")
  SF-OPTION "Was soll geändert werden" '("Pausenzeit" "Pausenzeit und Einzelübergang" "Einzelübergang")
 	SF-ADJUSTMENT "Pausenzeit in ms " '(50 0 10000 1 10 0 1)
  SF-OPTION "Einzelübergang" '("Ersetzen" "Kombinieren" "Einzelübergang Entfernen")
 
 ;SF-TOGGLE "Irgendeine alternative Auswahl:" TRUE
)													;Ende (script-fu-register)

(script-fu-menu-register "script-fu-cf-tools-aniopt" "<Image>/CFU/Helferlein")		

